<template lang="pug">
.table-wrapper
	table.table.is-striped.is-hoverable.is-fullwidth
		thead
			tr
				th( v-for='({ label, field }, i) in columns' :key='i' )
					template( v-if='field == "checkbox"' )
						b-checkbox( :modelValue='activeAll' @input='emit("select-all", $event)' )
					template( v-else ) {{ label }}
		tbody
			template( v-if='data.length' )
				tr(
					v-for='(item, y) in data' :key='y'
					@click='emit("row-click", item)')
					td( 
						v-for='({ field, label }, i) in columns' :key='i'
						:class='field'
						:data-label='label')
						template( v-if='$slots[field]' )
							slot( :name='field' :item='item' :index='y' )
						template( v-else ) {{ item[field] }}
			tr( v-else )
				td.empty( :colspan='columns.length' )
					.is-flex.is-align-items-center.is-justify-content-flex-start
						p
							slot( v-if='$slots.empty' name="empty" )
							template( v-else ) Нет данных
	b-loading( :active='loading' )
</template>

<script setup>
import BCheckbox from "@/components/form/Checkbox.vue"

const props = defineProps({
	columns: {
		type: Array,
		default: () => []
	},
	data: {
		type: Array,
		default: () => []
	},
	loading: Boolean,
	activeAll: Boolean
})

const emit = defineEmits([ "row-click", "select-all" ])
</script>

<style lang="scss" scoped>
.table-wrapper {
	position: relative;
}

td {
	vertical-align: middle;
	border: unset!important;
}

tr {
	&:not(:last-of-type) {
		border-bottom: 1px solid $light!important;
	}
}
</style>